/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.29 Revision 1.82
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.29 2005/02/06 20:36:42 genstef Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.82 2008/09/30 05:27:42 vapier Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way 5# Description: This eclass is used to interface with linux-info in such a way
6# to provide the functionality required and initial functions 6# to provide the functionality required and initial functions
7# required to install external modules against a kernel source 7# required to install external modules against a kernel source
8# tree. 8# tree.
9# 9#
10# Maintainer: John Mylchreest <johnm@gentoo.org> 10# Author(s): John Mylchreest <johnm@gentoo.org>,
11# Copyright 2004 Gentoo Linux 11# Stefan Schweizer <genstef@gentoo.org>
12# Maintainer: kernel-misc@gentoo.org
12# 13#
13# Please direct your bugs to the current eclass maintainer :) 14# Please direct your bugs to the current eclass maintainer :)
14 15
15# A Couple of env vars are available to effect usage of this eclass 16# A Couple of env vars are available to effect usage of this eclass
16# These are as follows: 17# These are as follows:
17# 18#
18# Env Var Option Default Description 19# Env Var Option Default Description
19# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 20# KERNEL_DIR <string> /usr/src/linux The directory containing kernel
20# the target kernel sources. 21# the target kernel sources.
21# ECONF_PARAMS <string> The parameters to pass to econf. 22# ECONF_PARAMS <string> The parameters to pass to econf.
22# If this is not set, then econf 23# If this is not set, then econf
23# isn't run. 24# isn't run.
24# BUILD_PARAMS <string> The parameters to pass to emake. 25# BUILD_PARAMS <string> The parameters to pass to emake.
25# BUILD_TARGETS <string> clean modules The build targets to pass to 26# BUILD_TARGETS <string> clean modules The build targets to pass to
26# make. 27# make.
27# MODULE_NAMES <string> This is the modules which are 28# MODULE_NAMES <string> This is the modules which are
28# to be built automatically using 29# to be built automatically using
29# the default pkg_compile/install. 30# the default pkg_compile/install.
30# They are explained properly 31# They are explained properly
31# below. It will only make 32# below. It will only make
32# BUILD_TARGETS once in any 33# BUILD_TARGETS once in any
33# directory. 34# directory.
34 35
35# MODULE_NAMES - Detailed Overview 36# MODULE_NAMES - Detailed Overview
36# 37#
37# The structure of each MODULE_NAMES entry is as follows: 38# The structure of each MODULE_NAMES entry is as follows:
38# modulename(libdir:srcdir:objdir) 39# modulename(libdir:srcdir:objdir)
39# for example: 40# for example:
40# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 41# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
41# 42#
42# what this would do is 43# what this would do is
43# cd ${S}/pci 44# cd ${S}/pci
44# make ${BUILD_PARAMS} ${BUILD_TARGETS} 45# make ${BUILD_PARAMS} ${BUILD_TARGETS}
45# cd ${S} 46# cd ${S}
46# insinto /lib/modules/${KV_FULL}/pci 47# insinto /lib/modules/${KV_FULL}/pci
54# 55#
55# if the srcdir isnt specified, it assumes ${S} 56# if the srcdir isnt specified, it assumes ${S}
56# if the libdir isnt specified, it assumes misc. 57# if the libdir isnt specified, it assumes misc.
57# if the objdir isnt specified, it assumes srcdir 58# if the objdir isnt specified, it assumes srcdir
58 59
59# There is also support for automatyed modules.d file generation. 60# There is also support for automated modprobe.d/modules.d(2.4) file generation.
60# This can be explicitly enabled by setting any of the following variables. 61# This can be explicitly enabled by setting any of the following variables.
61# 62#
62# 63#
63# MODULESD_${modulename}_ENABLED This enables the modules.d file 64# MODULESD_${modulename}_ENABLED This enables the modules.d file
64# generation even if we dont 65# generation even if we dont
76# Each entry is a new line. 77# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains 78# MODULES_${modulename}_DOCS This is a string list which contains
78# the full path to any associated 79# the full path to any associated
79# documents for $modulename 80# documents for $modulename
80 81
82# The order of these is important as both of linux-info and eutils contain
83# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
84# are deprecated in favor of the ones in linux-info.
85# See http://bugs.gentoo.org/show_bug.cgi?id=127506
81 86
82inherit linux-info 87inherit eutils linux-info multilib
83ECLASS=linux-mod
84INHERITED="$INHERITED $ECLASS"
85EXPORT_FUNCTIONS pkg_setup pkg_postinst src_install src_compile \ 88EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
86 src_compile_userland src_install_userland
87 89
90IUSE="kernel_linux"
88SLOT="0" 91SLOT="0"
89DESCRIPTION="Based on the $ECLASS eclass" 92DESCRIPTION="Based on the $ECLASS eclass"
90DEPEND="virtual/linux-sources 93RDEPEND="kernel_linux? ( virtual/modutils )"
94DEPEND="${RDEPEND}
91 sys-apps/sed 95 sys-apps/sed"
92 virtual/modutils"
93
94 96
95# eclass utilities 97# eclass utilities
96# ---------------------------------- 98# ----------------------------------
97 99
100check_vermagic() {
101 debug-print-function ${FUNCNAME} $*
102
103 local curr_gcc_ver=$(gcc -dumpversion)
104 local tmpfile old_chost old_gcc_ver result=0
105
106 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
107 tmpfile=${tmpfile//*usr/lib}
108 tmpfile=${tmpfile//\/include*}
109 old_chost=${tmpfile//*gcc\/}
110 old_chost=${old_chost//\/*}
111 old_gcc_ver=${tmpfile//*\/}
112
113 if [[ -z ${old_gcc_ver} || -z ${old_chost} ]]; then
114 ewarn ""
115 ewarn "Unable to detect what version of GCC was used to compile"
116 ewarn "the kernel. Build will continue, but you may experience problems."
117 elif [[ ${curr_gcc_ver} != ${old_gcc_ver} ]]; then
118 ewarn ""
119 ewarn "The version of GCC you are using (${curr_gcc_ver}) does"
120 ewarn "not match the version of GCC used to compile the"
121 ewarn "kernel (${old_gcc_ver})."
122 result=1
123 elif [[ ${CHOST} != ${old_chost} ]]; then
124 ewarn ""
125 ewarn "The current CHOST (${CHOST}) does not match the chost"
126 ewarn "used when compiling the kernel (${old_chost})."
127 result=1
128 fi
129
130 if [[ ${result} -gt 0 ]]; then
131 ewarn ""
132 ewarn "Build will not continue, because you will experience problems."
133 ewarn "To fix this either change the version of GCC you wish to use"
134 ewarn "to match the kernel, or recompile the kernel first."
135 die "GCC Version Mismatch."
136 fi
137}
138
98use_m() { 139use_m() {
140 debug-print-function ${FUNCNAME} $*
141
99 # if we haven't determined the version yet, we need too. 142 # if we haven't determined the version yet, we need too.
100 get_version; 143 get_version;
101 144
102 # if the kernel version is greater than 2.6.6 then we should use 145 # if the kernel version is greater than 2.6.6 then we should use
103 # M= instead of SUBDIRS= 146 # M= instead of SUBDIRS=
104 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 147 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
105 return 0 || return 1 148 return 0 || return 1
106} 149}
107 150
108convert_to_m() { 151convert_to_m() {
109 [ ! -f "${1}" ] && die "convert_to_m() requires a filename as an argument" 152 debug-print-function ${FUNCNAME} $*
153
110 if use_m 154 if use_m
111 then 155 then
156 [ ! -f "${1}" ] && \
157 die "convert_to_m() requires a filename as an argument"
112 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 158 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
113 sed -i 's:SUBDIRS=:M=:g' ${1} 159 sed -i 's:SUBDIRS=:M=:g' ${1}
114 eend $? 160 eend $?
115 fi 161 fi
116} 162}
117 163
118update_depmod() { 164update_depmod() {
165 debug-print-function ${FUNCNAME} $*
166
119 # if we haven't determined the version yet, we need too. 167 # if we haven't determined the version yet, we need too.
120 get_version; 168 get_version;
121 169
122 ebegin "Updating module dependencies for ${KV_FULL}" 170 ebegin "Updating module dependencies for ${KV_FULL}"
123 if [ -r ${KV_OUT_DIR}/System.map ] 171 if [ -r ${KV_OUT_DIR}/System.map ]
124 then 172 then
125 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL} 173 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL}
126 eend $? 174 eend $?
132 ewarn 180 ewarn
133 fi 181 fi
134} 182}
135 183
136update_modules() { 184update_modules() {
185 debug-print-function ${FUNCNAME} $*
186
137 if [ -x /sbin/modules-update ] && \ 187 if [ -x /sbin/update-modules ] && \
138 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 188 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
139 ebegin "Updating modules.conf" 189 ebegin "Updating modules.conf"
140 /sbin/modules-update 190 /sbin/update-modules
141 eend $? 191 eend $?
192 elif [ -x /sbin/update-modules ] && \
193 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
194 ebegin "Updating modules.conf"
195 /sbin/update-modules
196 eend $?
197 fi
198}
199
200move_old_moduledb() {
201 debug-print-function ${FUNCNAME} $*
202
203 local OLDDIR=${ROOT}/usr/share/module-rebuild/
204 local NEWDIR=${ROOT}/var/lib/module-rebuild/
205
206 if [[ -f ${OLDDIR}/moduledb ]]; then
207 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR}
208 [[ ! -f ${NEWDIR}/moduledb ]] && \
209 mv ${OLDDIR}/moduledb ${NEWDIR}/moduledb
210 rm -f ${OLDDIR}/*
211 rmdir ${OLDDIR}
212 fi
213}
214
215update_moduledb() {
216 debug-print-function ${FUNCNAME} $*
217
218 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
219 move_old_moduledb
220
221 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then
222 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR}
223 touch ${MODULEDB_DIR}/moduledb
224 fi
225
226 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
227 einfo "Adding module to moduledb."
228 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb
229 fi
230}
231
232remove_moduledb() {
233 debug-print-function ${FUNCNAME} $*
234
235 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
236 move_old_moduledb
237
238 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
239 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
240 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb
142 fi 241 fi
143} 242}
144 243
145set_kvobj() { 244set_kvobj() {
245 debug-print-function ${FUNCNAME} $*
246
146 if kernel_is 2 6 247 if kernel_is 2 6
147 then 248 then
148 KV_OBJ="ko" 249 KV_OBJ="ko"
149 else 250 else
150 KV_OBJ="o" 251 KV_OBJ="o"
152 # Do we really need to know this? 253 # Do we really need to know this?
153 # Lets silence it. 254 # Lets silence it.
154 # einfo "Using KV_OBJ=${KV_OBJ}" 255 # einfo "Using KV_OBJ=${KV_OBJ}"
155} 256}
156 257
258get-KERNEL_CC() {
259 debug-print-function ${FUNCNAME} $*
260
261 if [[ -n ${KERNEL_CC} ]] ; then
262 echo "${KERNEL_CC}"
263 return
264 fi
265
266 local kernel_cc
267 if [ -n "${KERNEL_ABI}" ]; then
268 # In future, an arch might want to define CC_$ABI
269 #kernel_cc="$(get_abi_CC)"
270 #[ -z "${kernel_cc}" ] &&
271 kernel_cc="$(tc-getCC $(ABI=${KERNEL_ABI} get_abi_CHOST))"
272 else
273 kernel_cc=$(tc-getCC)
274 fi
275 echo "${kernel_cc}"
276}
277
157generate_modulesd() { 278generate_modulesd() {
279 debug-print-function ${FUNCNAME} $*
280
158 # This function will generate the neccessary modules.d file from the 281 # This function will generate the neccessary modules.d file from the
159 # information contained in the modules exported parms 282 # information contained in the modules exported parms
160 283
161 local currm_path currm t myIFS myVAR 284 local currm_path currm currm_t t myIFS myVAR
162 local module_docs module_enabled module_aliases \ 285 local module_docs module_enabled module_aliases \
163 module_additions module_examples module_modinfo module_opts 286 module_additions module_examples module_modinfo module_opts
164 287
165 for currm_path in ${@} 288 for currm_path in ${@}
166 do 289 do
167 currm=${currm_path//*\/} 290 currm=${currm_path//*\/}
168 currm=$(echo ${currm} | tr '[:lower:]' '[:upper:]') 291 currm=$(echo ${currm} | tr '[:lower:]' '[:upper:]')
292 currm_t=${currm}
293 while [[ -z ${currm_t//*-*} ]]; do
294 currm_t=${currm_t/-/_}
295 done
169 296
170 module_docs="$(eval echo \${MODULESD_${currm}_DOCS})" 297 module_docs="$(eval echo \${MODULESD_${currm_t}_DOCS})"
171 module_enabled="$(eval echo \${MODULESD_${currm}_ENABLED})" 298 module_enabled="$(eval echo \${MODULESD_${currm_t}_ENABLED})"
172 module_aliases="$(eval echo \${#MODULESD_${currm}_ALIASES[*]})" 299 module_aliases="$(eval echo \${#MODULESD_${currm_t}_ALIASES[*]})"
173 module_additions="$(eval echo \${#MODULESD_${currm}_ADDITIONS[*]})" 300 module_additions="$(eval echo \${#MODULESD_${currm_t}_ADDITIONS[*]})"
174 module_examples="$(eval echo \${#MODULESD_${currm}_EXAMPLES[*]})" 301 module_examples="$(eval echo \${#MODULESD_${currm_t}_EXAMPLES[*]})"
175 302
176 [[ ${module_aliases} -eq 0 ]] && unset module_aliases 303 [[ ${module_aliases} -eq 0 ]] && unset module_aliases
177 [[ ${module_additions} -eq 0 ]] && unset module_additions 304 [[ ${module_additions} -eq 0 ]] && unset module_additions
178 [[ ${module_examples} -eq 0 ]] && unset module_examples 305 [[ ${module_examples} -eq 0 ]] && unset module_examples
179 306
180 # If we specify we dont want it, then lets exit, otherwise we assume 307 # If we specify we dont want it, then lets exit, otherwise we assume
181 # that if its set, we do want it. 308 # that if its set, we do want it.
182 [[ ${module_enabled} == no ]] && return 0 309 [[ ${module_enabled} == no ]] && return 0
183 310
184 # unset any unwanted variables. 311 # unset any unwanted variables.
185 for t in ${!module_*} 312 for t in ${!module_*}
226 echo >> ${module_config} 353 echo >> ${module_config}
227 echo "# Configurable module parameters" >> ${module_config} 354 echo "# Configurable module parameters" >> ${module_config}
228 echo "# ------------------------------" >> ${module_config} 355 echo "# ------------------------------" >> ${module_config}
229 myIFS="${IFS}" 356 myIFS="${IFS}"
230 IFS="$(echo -en "\n\b")" 357 IFS="$(echo -en "\n\b")"
231 358
232 for t in ${module_modinfo} 359 for t in ${module_modinfo}
233 do 360 do
234 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")" 361 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")"
235 if [[ -n ${myVAR} ]] 362 if [[ -n ${myVAR} ]]
236 then 363 then
237 module_opts="${module_opts} ${t%%:*}:${myVAR}" 364 module_opts="${module_opts} ${t%%:*}:${myVAR}"
238 fi 365 fi
239 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config} 366 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config}
240 done 367 done
241 IFS="${myIFS}" 368 IFS="${myIFS}"
242 echo '' >> ${module_config} 369 echo '' >> ${module_config}
243 fi 370 fi
244 371
245 #----------------------------------------------------------------------- 372 #-----------------------------------------------------------------------
276 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \ 403 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \
277 >> ${module_config} 404 >> ${module_config}
278 done 405 done
279 echo '' >> ${module_config} 406 echo '' >> ${module_config}
280 fi 407 fi
281 408
282 #----------------------------------------------------------------------- 409 #-----------------------------------------------------------------------
283 410
284 # then we install it 411 # then we install it
412 if kernel_is ge 2 6; then
413 insinto /etc/modprobe.d
414 else
285 insinto /etc/modules.d 415 insinto /etc/modules.d
416 fi
286 newins ${module_config} ${currm_path//*\/} 417 newins ${module_config} ${currm_path//*\/}
287 418
288 # and install any documentation we might have. 419 # and install any documentation we might have.
289 [[ -n ${module_docs} ]] && dodoc ${module_docs} 420 [[ -n ${module_docs} ]] && dodoc ${module_docs}
290 done 421 done
291 eend 0 422 eend 0
292 return 0 423 return 0
293} 424}
294 425
295display_postinst() {
296 # if we haven't determined the version yet, we need too.
297 get_version;
298
299 local modulename moduledir sourcedir moduletemp file i
300
301 file=${ROOT}/etc/modules.autoload.d/kernel-${KV_MAJOR}.${KV_MINOR}
302 file=${file/\/\///}
303
304 for i in ${MODULE_IGNORE}
305 do
306 MODULE_NAMES=${MODULE_NAMES//${i}(*}
307 done
308
309 if [[ -n ${MODULE_NAMES} ]]
310 then
311 einfo "If you would like to load this module automatically upon boot"
312 einfo "please type the following as root:"
313 for i in ${MODULE_NAMES}
314 do
315 unset libdir srcdir objdir
316 for n in $(find_module_params ${i})
317 do
318 eval ${n/:*}=${n/*:/}
319 done
320 einfo " # echo \"${modulename}\" >> ${file}"
321 done
322 einfo
323 fi
324}
325
326find_module_params() { 426find_module_params() {
427 debug-print-function ${FUNCNAME} $*
428
327 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 429 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
328 local i=0 y=0 z=0 430 local i=0 y=0 z=0
329 431
330 for((i=0; i<=${#test}; i++)) 432 for((i=0; i<=${#test}; i++))
331 do 433 do
332 case ${test:${i}:1} in 434 case ${test:${i}:1} in
333 \() matched_offset[0]=${i};; 435 \() matched_offset[0]=${i};;
334 \:) matched_opts=$((${matched_opts} + 1)); 436 \:) matched_opts=$((${matched_opts} + 1));
335 matched_offset[${matched_opts}]="${i}";; 437 matched_offset[${matched_opts}]="${i}";;
336 \)) matched_opts=$((${matched_opts} + 1)); 438 \)) matched_opts=$((${matched_opts} + 1));
337 matched_offset[${matched_opts}]="${i}";; 439 matched_offset[${matched_opts}]="${i}";;
338 esac 440 esac
339 done 441 done
340 442
341 for((i=0; i<=${matched_opts}; i++)) 443 for((i=0; i<=${matched_opts}; i++))
342 do 444 do
343 # i = offset were working on 445 # i = offset were working on
344 # y = last offset 446 # y = last offset
345 # z = current offset - last offset 447 # z = current offset - last offset
349 *) y=$((${matched_offset[$((${i} - 1))]} + 1)) 451 *) y=$((${matched_offset[$((${i} - 1))]} + 1))
350 z=$((${matched_offset[${i}]} - ${matched_offset[$((${i} - 1))]})); 452 z=$((${matched_offset[${i}]} - ${matched_offset[$((${i} - 1))]}));
351 z=$((${z} - 1)) 453 z=$((${z} - 1))
352 tempvar=${test:${y}:${z}};; 454 tempvar=${test:${y}:${z}};;
353 esac 455 esac
354 456
355 case ${i} in 457 case ${i} in
356 0) result="${result} modulename:${tempvar}";; 458 0) result="${result} modulename:${tempvar}";;
357 1) result="${result} libdir:${tempvar}";; 459 1) result="${result} libdir:${tempvar}";;
358 2) result="${result} srcdir:${tempvar}";; 460 2) result="${result} srcdir:${tempvar}";;
359 3) result="${result} objdir:${tempvar}";; 461 3) result="${result} objdir:${tempvar}";;
360 esac 462 esac
361 done 463 done
362 464
363 echo ${result} 465 echo ${result}
364} 466}
365 467
366# default ebuild functions 468# default ebuild functions
367# -------------------------------- 469# --------------------------------
368 470
369linux-mod_pkg_setup() { 471linux-mod_pkg_setup() {
472 debug-print-function ${FUNCNAME} $*
473
370 linux-info_pkg_setup; 474 linux-info_pkg_setup;
475 require_configured_kernel
371 check_kernel_built; 476 check_kernel_built;
372 check_modules_supported; 477 strip_modulenames;
478 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
373 set_kvobj; 479 set_kvobj;
480 # Commented out with permission from johnm until a fixed version for arches
481 # who intentionally use different kernel and userland compilers can be
482 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
483 #check_vermagic;
374} 484}
375 485
376linux-mod_src_compile_userland() { 486strip_modulenames() {
377 return 0 487 debug-print-function ${FUNCNAME} $*
378}
379 488
380linux-mod_src_install_userland() { 489 local i
381 return 0
382}
383
384linux-mod_src_compile() {
385 local modulename libdir srcdir objdir i n myARCH="${ARCH}"
386 unset ARCH
387
388 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
389
390 for i in ${MODULE_IGNORE} 490 for i in ${MODULE_IGNORE}; do
391 do
392 MODULE_NAMES=${MODULE_NAMES//${i}(*} 491 MODULE_NAMES=${MODULE_NAMES//${i}(*}
393 done 492 done
493}
394 494
495linux-mod_src_compile() {
496 debug-print-function ${FUNCNAME} $*
497
498 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}"
499 ARCH="$(tc-arch-kernel)"
500 ABI="${KERNEL_ABI}"
501
502 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
503 strip_modulenames;
504 cd "${S}"
395 for i in ${MODULE_NAMES} 505 for i in ${MODULE_NAMES}
396 do 506 do
397 unset libdir srcdir objdir 507 unset libdir srcdir objdir
398 for n in $(find_module_params ${i}) 508 for n in $(find_module_params ${i})
399 do 509 do
400 eval ${n/:*}=${n/*:/} 510 eval ${n/:*}=${n/*:/}
401 done 511 done
402 libdir=${libdir:-misc} 512 libdir=${libdir:-misc}
403 srcdir=${srcdir:-${S}} 513 srcdir=${srcdir:-${S}}
404 objdir=${objdir:-${srcdir}} 514 objdir=${objdir:-${srcdir}}
405 515
406 if [ ! -f "${srcdir}/.built" ]; 516 if [ ! -f "${srcdir}/.built" ];
407 then 517 then
408 cd ${srcdir} 518 cd ${srcdir}
409 einfo "Preparing ${modulename} module" 519 einfo "Preparing ${modulename} module"
410 if [[ -n ${ECONF_PARAMS} ]] 520 if [[ -n ${ECONF_PARAMS} ]]
411 then 521 then
412 econf ${ECONF_PARAMS} || \ 522 econf ${ECONF_PARAMS} || \
413 die "Unable to run econf ${ECONF_PARAMS}" 523 die "Unable to run econf ${ECONF_PARAMS}"
414 fi 524 fi
415 525
416 emake ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \ 526 # This looks messy, but it is needed to handle multiple variables
417 || die "Unable to make \ 527 # being passed in the BUILD_* stuff where the variables also have
418 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}." 528 # spaces that must be preserved. If don't do this, then the stuff
529 # inside the variables gets used as targets for Make, which then
530 # fails.
531 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
532 CC=\"$(get-KERNEL_CC)\" \
533 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
534 ${BUILD_FIXES} \
535 ${BUILD_PARAMS} \
536 ${BUILD_TARGETS} " \
537 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
419 touch ${srcdir}/.built 538 touch ${srcdir}/.built
420 cd ${OLDPWD} 539 cd ${OLDPWD}
421 fi 540 fi
422 done 541 done
423 542
424 ARCH="${myARCH}" 543 ARCH="${myARCH}"
544 ABI="${myABI}"
425} 545}
426 546
427linux-mod_src_install() { 547linux-mod_src_install() {
548 debug-print-function ${FUNCNAME} $*
549
428 local modulename libdir srcdir objdir i n 550 local modulename libdir srcdir objdir i n
429
430 for i in ${MODULE_IGNORE}
431 do
432 MODULE_NAMES=${MODULE_NAMES//${i}(*}
433 done
434 551
552 strip_modulenames;
435 for i in ${MODULE_NAMES} 553 for i in ${MODULE_NAMES}
436 do 554 do
437 unset libdir srcdir objdir 555 unset libdir srcdir objdir
438 for n in $(find_module_params ${i}) 556 for n in $(find_module_params ${i})
439 do 557 do
442 libdir=${libdir:-misc} 560 libdir=${libdir:-misc}
443 srcdir=${srcdir:-${S}} 561 srcdir=${srcdir:-${S}}
444 objdir=${objdir:-${srcdir}} 562 objdir=${objdir:-${srcdir}}
445 563
446 einfo "Installing ${modulename} module" 564 einfo "Installing ${modulename} module"
447 cd ${objdir} 565 cd ${objdir} || die "${objdir} does not exist"
448 insinto ${ROOT}lib/modules/${KV_FULL}/${libdir} 566 insinto /lib/modules/${KV_FULL}/${libdir}
449 doins ${modulename}.${KV_OBJ} 567 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
450 cd ${OLDPWD} 568 cd ${OLDPWD}
451 569
452 generate_modulesd ${objdir}/${modulename} 570 generate_modulesd ${objdir}/${modulename}
453 done 571 done
454} 572}
455 573
574linux-mod_pkg_preinst() {
575 debug-print-function ${FUNCNAME} $*
576
577 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
578 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
579 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
580}
581
456linux-mod_pkg_postinst() { 582linux-mod_pkg_postinst() {
457 update_depmod; 583 debug-print-function ${FUNCNAME} $*
458 update_modules; 584
459 display_postinst; 585 ${UPDATE_DEPMOD} && update_depmod;
586 ${UPDATE_MODULES} && update_modules;
587 ${UPDATE_MODULEDB} && update_moduledb;
460} 588}
589
590linux-mod_pkg_postrm() {
591 debug-print-function ${FUNCNAME} $*
592 remove_moduledb;
593}

Legend:
Removed from v.1.29  
changed lines
  Added in v.1.82

  ViewVC Help
Powered by ViewVC 1.1.20